// -*- C++;indent-tabs-mode: t; tab-width: 4; c-basic-offset: 4; -*-
/*
 * id_test.cpp
 *
 *  Test suite program for C++ bindings
 */

#include <iostream>
#include <iomanip>
#include <usbpp.h>

using namespace std;

int main(void)
{

	USB::Busses buslist; 

	cout << "bus/device  idVendor/idProduct/bcdDevice  Class/SubClass/Protocol" << endl;

	USB::Bus *bus;
	USB::Device *device;

	for ( bus = buslist.first(); bus; bus = buslist.next() ) {
		for ( device = bus->first(); device; device = bus->next() ) {
			cout << bus->directoryName().latin1() << "/" 
				 << device->fileName().latin1() << "        "
				 << hex << setw(4) << setfill('0')
				 << device->idVendor() << "  /  "
				 << hex << setw(4) << setfill('0')
				 << device->idProduct() << "  /  "
				 << hex << setw(4) << setfill('0')
				 << device->idRevision() << "       "
				 << hex << setw(2) << setfill('0')
				 << int(device->devClass()) << "      " 
				 << hex << setw(2) << setfill('0')
				 << int(device->devSubClass()) << "      "
				 << hex << setw(2) << setfill('0')
				 << int(device->devProtocol()) << endl;
		}
	}

  
	return 0;
}
